JavaScript/jQuery DateBox - Accessibility

Accessibility Features Overview

NOTE
The overall accessibility level of your application depends on the DateBox features that you use.
Accessibility Requirement Support Level
Right-to-Left Support
Keyboard Navigation Support
Screen Reader Support
Contrast Color Theme
Mobile Device Support
Lighthouse Accessibility Validation
Axe Accessibility Validation
WAVE Accessibility Validation
Section 508 Support
WCAG 2.x Support
  • - All component features meet the requirement
  • - Some component features may not meet the requirement
  • - Accessibility requirement is not supported

Accessibility Standards Compliance

The DateBox component meets a variety of Section 508 and WCAG 2.x compliance standards. Known exceptions:

Section 508 criteria WCAG 2.x criteria Exception description
501 (Web)(Software)
504.2 (Authoring Tool)
602.3 (Support Docs)
1.4.3 Contrast (Minimum) (Level AA)
1.4.11 Non-text Contrast (Level AA 2.1 and 2.2)
DateBox does not support Windows High Contrast themes.

Keyboard Navigation

A user can use the following keys to interact with the DateBox component:

Value Picker Key Action
All Alt + ↓ / Alt + ↑ Opens/closes the value picker.
Esc Closes the date/time picker.
A / P Switches time to AM/PM respectively.
Calendar ← → ↑ ↓ Moves focus to the nearest date.
Page Up or Ctrl + ← Displays the previous month.
Page Down or Ctrl + → Displays the next month.
Enter Selects the focused day.
Alt + ↑ / Alt + ↓ Opens/closes the drop-down editor.
Esc Closes the drop-down editor.
Ctrl + ↑ Increases zoomLevel.
Ctrl + ↓ Decreases zoomLevel.
Home Moves focus to the first date in the view.
End Moves focus to the last date in the view.
List ↑ / ↓ Moves focus to the previous/next time value.
Enter Selects the focused time value.
Page Up / Page Down Moves focus to the first/last value.

Use the registerKeyHandler(key, handler) method to implement a custom handler for a key.

JavaScript
  • function registerKeyHandlers () {
  • const dateBox = $("#dateBoxContainer").dxDateBox("instance");
  • dateBox.registerKeyHandler("backspace", function(e) {
  • // The argument "e" contains information on the event
  • });
  • dateBox.registerKeyHandler("space", function(e) {
  • // ...
  • });
  • }

Screen Reader Support

The DateBox component supports screen readers and complies to WAI-ARIA standards.

To improve accessibility, use the inputAttr property to specify aria-label for the component. You do not need to specify aria-label if you use the label option.

React DateBox - Accessibility

Accessibility Features Overview

NOTE
The overall accessibility level of your application depends on the DateBox features that you use.
Accessibility Requirement Support Level
Right-to-Left Support
Keyboard Navigation Support
Screen Reader Support
Contrast Color Theme
Mobile Device Support
Lighthouse Accessibility Validation
Axe Accessibility Validation
WAVE Accessibility Validation
Section 508 Support
WCAG 2.x Support
  • - All component features meet the requirement
  • - Some component features may not meet the requirement
  • - Accessibility requirement is not supported

Accessibility Standards Compliance

The DateBox component meets a variety of Section 508 and WCAG 2.x compliance standards. Known exceptions:

Section 508 criteria WCAG 2.x criteria Exception description
501 (Web)(Software)
504.2 (Authoring Tool)
602.3 (Support Docs)
1.4.3 Contrast (Minimum) (Level AA)
1.4.11 Non-text Contrast (Level AA 2.1 and 2.2)
DateBox does not support Windows High Contrast themes.

Keyboard Navigation

A user can use the following keys to interact with the DateBox component:

Value Picker Key Action
All Alt + ↓ / Alt + ↑ Opens/closes the value picker.
Esc Closes the date/time picker.
A / P Switches time to AM/PM respectively.
Calendar ← → ↑ ↓ Moves focus to the nearest date.
Page Up or Ctrl + ← Displays the previous month.
Page Down or Ctrl + → Displays the next month.
Enter Selects the focused day.
Alt + ↑ / Alt + ↓ Opens/closes the drop-down editor.
Esc Closes the drop-down editor.
Ctrl + ↑ Increases zoomLevel.
Ctrl + ↓ Decreases zoomLevel.
Home Moves focus to the first date in the view.
End Moves focus to the last date in the view.
List ↑ / ↓ Moves focus to the previous/next time value.
Enter Selects the focused time value.
Page Up / Page Down Moves focus to the first/last value.

Use the registerKeyHandler(key, handler) method to implement a custom handler for a key.

App.js
  • import React from 'react';
  • import 'devextreme/dist/css/dx.light.css';
  •  
  • import { DateBox } from 'devextreme-react/date-box';
  •  
  • class App extends React.Component {
  • constructor(props) {
  • super(props);
  •  
  • this.dateBoxRef = React.createRef();
  • }
  •  
  • render() {
  • return (
  • <DateBox ref={this.dateBoxRef} />
  • );
  • }
  •  
  • get dateBox() {
  • return this.dateBoxRef.current.instance();
  • }
  •  
  • componentDidMount() {
  • this.dateBox.registerKeyHandler('backspace', function(e) {
  • // The argument "e" contains information on the event
  • });
  • this.dateBox.registerKeyHandler('space', function(e) {
  • // ...
  • });
  • }
  • }
  •  
  • export default App;

Screen Reader Support

The DateBox component supports screen readers and complies to WAI-ARIA standards.

To improve accessibility, use the inputAttr property to specify aria-label for the component. You do not need to specify aria-label if you use the label option.